!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

SUBROUTINE press_read(n1,n2,n3,un,vn,tn,zn,rn)

implicit none

integer :: n1,n2,n3
real, dimension(n1,n2,n3) :: un,vn,tn,zn,rn

include  'prep_com.h'

PRINT 91
91 FORMAT(////,1X,70('*')/  &
       ,'  Access pressure data',/  &
       ,1X,70('*')///)

!-----------------------------------------------------------------
!  Open the pressure input file.
!-----------------------------------------------------------------

open(21,file=innpr,status='old',form='formatted')

!-----------------------------------------------------------------
!  The only thing to do here is to read the input pressure file
!    and to fill up the 5 data arrays with the information in the
!    correct units at the correct time over the domain that was
!    requested in the namelist
!    parameters. These parameters are available through the common
!    blocks that are included. All missing values should be set to -999.
!    Insert a code segment in the following section to accomplish
!    these tasks.

!       The 5 data arrays are dimensioned by (nx,ny,nlev):
!           nx - number of points in east-west direction
!           ny - number of points in north-south direction
!           nlev - number of pressure levels
!
!       The data arrays are:
!           un - u-component (m/s)
!           vn - v-component (m/s)
!           tn - temerature (K)
!           zn - height (m)
!           rn - relative humidity (fraction)
!
!   Note: Grid point (1,1,1) of any of the data arrays is in the
!         lowest southwest corner of the domain.
!-----------------------------------------------------------------
!------------------------------------------------------------------

!       (Insert code here)
!             .
!             .
!             .
!             .
!             .

!-----------------------------------------------------------------
!------------------------------------------------------------------
close(21)

RETURN
END

