!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

SUBROUTINE read_sfc(iun,olat1,olat2,olon1,olon2)

implicit none

integer :: iun
real :: olat1,olat2,olon1,olon2

include 'prep_com.h'

character(len=8) :: idsta
integer :: iflags(3,5)

integer :: imarker,iver_sfc,nsss,iyr,imo,idy,ihr,n
real :: xlat,xlon,zx,ffx,ddx,tx,tdx,px,slp,pcp6,pcp24,sno,cf



real, parameter :: rmiss=-999.

!-----------------------------------------------------------------
!  Open the surface data input file.
!-----------------------------------------------------------------
PRINT 560,INSRFCE
560  FORMAT(/' Acquiring surface obs input file  ',A80)
OPEN(3,file=INSRFCE,status='old',form='FORMATTED')

! beg write ralph2 header for sfc:
      imarker=999999
      iver_sfc=2
      write(iun,'(i6,1x,i1)') imarker,iver_sfc
      write(iun,'(i2)')10
      write(iun,'(a14)')'WINDSPEED  m/s'
      write(iun,'(a19)')'WIND_DIRECTION  deg'
      write(iun,'(a14)')'TEMPERATURE  C'
      write(iun,'(a11)')'DEWPOINT  C'
      write(iun,'(a12)')'STN_PRES  Pa'
      write(iun,'(a7)')'SLP  Pa'
      write(iun,'(a12)')'6-HR_PCP  mm'
      write(iun,'(a13)')'24-HR_PCP  mm'
      write(iun,'(a14)')'SNOW_DEPTH  mm'
      write(iun,'(a21)')'CLOUD_COVER  fraction'
! end write ralph2 header for sfc

!-----------------------------------------------------------------
!  Start reading the surface obs. Modify the following code to read
!    your input file.
!-----------------------------------------------------------------

DO 10 NSSS=1,1000000

   READ(3,*,END=20,ERR=20)idsta,XLAT,XLON,zx  &
        ,ffx,ddx,tx,tdx,px

!-------------------------------------------------------------------
!  In the following section, modify the code to convert the input
!    variables to
!    SI units and appropriate form and fill up the following
!    variables and arrays. Set missing values to -999.
!
!     XLAT   - Station latitude (positive north, negative south)
!     XLON   - Station longitude (positive east, negative west)
!       ZX   - Station elevation (meters MSL)
!      DDX   - Wind direction (degrees)
!      FFX   - Wind speed (m/s)
!       TX   - Temperature (Celsius)
!      TDX   - Dewpoint temperature (Celsius)
!       PX   - Surface pressure (Pascals) (Station pressure, not sea level)
!-----------------------------------------------------------------------
!
XLON=-XLON

IF(TX.GT.50..OR.TX.LT.-50.) TX=-999.

IF(TDX.GT.50..OR.TDX.LT.-50.) TDX=-999.

IF(DDX.GT.360. .or. DDX .LT. 0.) DDX=-999.

IF(FFX.LT.998.)FFX=FFX*.5144

IF(PX.GT.106000..OR.PX.LT.75000.) PX=-999.

ZX=zx
!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
!  Write out the surface obs to the opened file in the "standard"
!     RAMS format.

    call setflags_f(ffx,rmiss,iflags(1,1))
    call setflags_f(ddx,rmiss,iflags(1,2))
    call setflags_f(tx, rmiss,iflags(1,3))
    call setflags_f(tdx,rmiss,iflags(1,4))
    call setflags_f(px, rmiss,iflags(1,5))

    slp=rmiss
    pcp6=rmiss
    pcp24=rmiss
    sno=rmiss
    cf=rmiss

  write(6,530) iyr+1900,imo,idy,ihr,idsta,xlat,xlon,zx
530    format('sfc obs found  '  &
     ,i4.4,2i3,3x,i4.4,3x,a6,5x,3(2x,f10.5))

! beg write ralph2 data for sfc:

    write(iun,5)iyr+1900,imo,idy,ihr,idsta  &
          ,xlat,xlon,zx  &
          ,ffx,(iflags(n,1),n=1,3)  &
          ,ddx,(iflags(n,2),n=1,3)  &
          ,tx,(iflags(n,3),n=1,3)  &
          ,tdx,(iflags(n,4),n=1,3)  &
          ,px,(iflags(n,5),n=1,3)  &
          ,slp,999  &
          ,pcp6,999,pcp24,999,sno,999  &
          ,cf,999

5       FORMAT(i4.4,2x,2(i2.2,2x),i4.4,1x,a8  &
          ,2f9.3,f6.0  &
          ,f9.2,2x,3i1  &
          ,f7.0,2x,3i1  &
          ,2(f8.1,2x,3i1)  &
          ,f10.1,2x,3i1  &
          ,f10.1,2x,i3.3  &
          ,3(f7.1,2x,i3.3),2x  &
          ,f5.0,2x,i3.3)

! end write ralph2 data for sfc
!-----------------------------------------------------------------------

10   CONTINUE

20   CONTINUE
CLOSE(3)

RETURN
END
